function varargout = FilterConfiguration(varargin)
% FILTERCONFIGURATION MATLAB code for FilterConfiguration.fig
%      FILTERCONFIGURATION, by itself, creates a new FILTERCONFIGURATION or raises the existing
%      singleton*.
%
%      H = FILTERCONFIGURATION returns the handle to a new FILTERCONFIGURATION or the handle to
%      the existing singleton*.
%
%      FILTERCONFIGURATION('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in FILTERCONFIGURATION.M with the given input arguments.
%
%      FILTERCONFIGURATION('Property','Value',...) creates a new FILTERCONFIGURATION or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before FilterConfiguration_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to FilterConfiguration_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help FilterConfiguration

% Last Modified by GUIDE v2.5 17-Jun-2013 13:02:22

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @FilterConfiguration_OpeningFcn, ...
    'gui_OutputFcn',  @FilterConfiguration_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before FilterConfiguration is made visible.
function FilterConfiguration_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to FilterConfiguration (see VARARGIN)

% Choose default command line output for FilterConfiguration
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);
global cellmatrix exportmat
cellmatrix = cell2mat(varargin(1));
filtercolumnformat=get(handles.filterconfig,'ColumnFormat');
filtercolumnformat{1,2}=exportmat{1,11};
filtercolumnformat{1,6}=filtercolumnformat{1,2};
set(handles.filterconfig,'ColumnFormat',filtercolumnformat);

filtercolumndata=get(handles.filterconfig,'Data');
filtercolumndata(:,1)={boolean(0)};
filtercolumndata(:,[2,6])={'none'};
filtercolumndata(:,[3,7])={'>='};
filtercolumndata(:,[4,8])={0};
filtercolumndata(:,5)={'DONE'};
set(handles.filterconfig,'Data',filtercolumndata);


set(handles.popupmenu_NormMode,'String',{'0.4-max CorrCoeff -> Alpha 0.1-0.8', 'ABS(min-max CorrCoeff)-> Alpha 0.1-0.8'});
set(handles.popupmenu_colorbar,'String',{'Blue','Green','Red','Cyan','Magenta','Yellow'});

% UIWAIT makes FilterConfiguration wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = FilterConfiguration_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
global filtersettings exportmat cellmatrix region filternames showlegend h_cam

%filterstandardsettings=

filtersettings=get(handles.filterconfig,'Data');
output=cellmatrix;
output(:,4:5)=[];

tempresult_left=zeros(size(exportmat,1),size(filtersettings,1));
tempresult_right=tempresult_left;
finallogical=tempresult_left;
clear filternames
for k=1:size(filtersettings,1)
    if strcmpi(filtersettings(k,5),'&&') || strcmpi(filtersettings(k,5),'||')
        filternames{k,1}=[filtersettings{k,2} filtersettings{k,3}, num2str(filtersettings{k,4}), filtersettings{k,5}, filtersettings{k,6},filtersettings{k,7}, num2str(filtersettings{k,8})];
    else
        filternames{k,1}=[filtersettings{k,2}, filtersettings{k,3}, num2str(filtersettings{k,4})];
    end
    
    
    if filtersettings{k,1}==1
        for m=1:size(exportmat,1)
            temp=exportmat{m,9}(find(strcmpi(exportmat{m,11},filtersettings(k,2)))); %left side filter
            if strcmpi(filtersettings(k,3),'>=')
                tempresult_left(m,k)=temp.*(temp>=filtersettings{k,4});
                templogical_left(m,k)=temp>=filtersettings{k,4};
            elseif strcmpi(filtersettings(k,3),'<=')
                tempresult_left(m,k)=temp.*(temp<=filtersettings{k,4});
                templogical_left(m,k)=temp<=filtersettings{k,4};
            end
            
            if strcmpi(filtersettings(k,5),'&&') || strcmpi(filtersettings(k,5),'||') %right side filter
                temp=exportmat{m,9}(find(strcmpi(exportmat{m,11},filtersettings(k,6))));
                if strcmpi(filtersettings(k,7),'>=')
                    tempresult_right(m,k)=temp.*(temp>=filtersettings{k,8});
                    templogical_right(m,k)=temp>=filtersettings{k,8};
                elseif strcmpi(filtersettings(k,7),'<=')
                    tempresult_right(m,k)=temp.*(temp<=filtersettings{k,8});
                    templogical_right(m,k)=temp<=filtersettings{k,8};
                end
            end
            
            if strcmpi(filtersettings(k,5),'DONE')
                finallogical(m,k)=templogical_left(m,k);
            elseif strcmpi(filtersettings(k,5),'&&')
                if (templogical_left(m,k)==0) || (templogical_right(m,k)==0)
                    finallogical(m,k)=0;
                else
                    finallogical(m,k)=1;
                end
            elseif strcmpi(filtersettings(k,5),'||')
                if (templogical_left(m,k)==1) || (templogical_right(m,k)==1)
                    finallogical(m,k)=1;
                else
                    finallogical(m,k)=0;
                end
            end
            
        end
    else filternames{k,1}=['not assigned'];
    end
end
filternames{end+1,1}=['multiple classes assigned']

for r=1:size(finallogical,1)
    if sum(finallogical(r,:),2)==0
        output(r,4)=1;
        output(r,5)=0.2;
    elseif sum(finallogical(r,:),2)==1
        indtrue=find(finallogical(r,:)==1);
        output(r,4)=indtrue+1;
        output(r,5)=abs(tempresult_left(r,indtrue));
    else
        output(r,4)=9;
        output(r,5)=0.7;
    end
end

if get(handles.checkbox_alphacoding,'Value')==0
    output(:,5)=0.5;
else
    cmap=flipud(gray(64));
    templist=output;
    templist(templist(:,4)==1,:)=[];
    if get(handles.checkbox_NormAlphaCoding,'Value')==1
        cmap=cmap*0.7+0.1;
        switch get(handles.popupmenu_NormMode,'Value')
            case 1; % '0.4-max CorrCoeff -> Alpha 0.1-0.8'
                prenormrange=(max(templist(:,5))-0.4);
                newcaxis=[0.4 max(templist(:,5))];
                output(:,5)=output(:,5)*(0.7/prenormrange)-0.4*(0.7/prenormrange)+0.1;
                output(output(:,5)<0,5)=0;
                
            case 2; % 'ABS(min-max CorrCoeff)-> Alpha 0.1-0.8'
                prenormrange=max(abs(templist(:,5)))-min(abs(templist(:,5)));
                newcaxis=[min(abs(templist(:,5))) max(abs(templist(:,5)))];
                output(:,5)=abs(output(:,5))*(0.7/prenormrange)-min(abs(templist(:,5)))*(0.7/prenormrange)+0.1;
                output(output(:,5)<0,5)=0;
                
        end
        
    output(output(:,4)==8,5)=0.3; %fixed grey (darker grey)
    output(output(:,4)==9,5)=0.6; %multipy assigned cells (black)
        
    end
    switch get(handles.popupmenu_colorbar,'Value')
        case 1;
        cmap(1:end,3)=1; % tint colorbar blue
        case 2;
        cmap(1:end,2)=1; % tint colorbar green
        case 3;
        cmap(1:end,1)=1; % tint colorbar red
        case 4;
        cmap(1:end,2:3)=1; % tint colorbar cyan
        case 5;
        cmap(1:end,[1,3])=1; % tint colorbar magenta
        case 6;
        cmap(1:end,[1,2])=1; % tint colorbar yellow
    end
end

if get(handles.checkbox_hideunclassifiedcells,'Value')==1
   output(output(:,4)==1,5)=0; %Set transparency of unclassified cells = 0
else
   output(output(:,4)==1,5)=0.1; %Set transparency of unclassified cells = 0.2
end




%filternames{1}='non-classified cells';
shownumbershandle=findobj('Tag','checkbox_shownumbers');
h_cam=show3dposition_5_131005(output,get(shownumbershandle,'Value'),region,showlegend,filternames);
if showlegend && get(handles.checkbox_NormAlphaCoding,'Value')==1
figure(98)

colormap(cmap);
colorbar('Location','EastOutside');
caxis(newcaxis);
end


% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in checkbox_alphacoding.
function checkbox_alphacoding_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_alphacoding (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% Hint: get(hObject,'Value') returns toggle state of checkbox_alphacoding


% --- Executes on button press in checkbox_NormAlphaCoding.
function checkbox_NormAlphaCoding_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_NormAlphaCoding (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_NormAlphaCoding


% --- Executes on selection change in popupmenu_NormMode.
function popupmenu_NormMode_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_NormMode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_NormMode contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_NormMode


% --- Executes during object creation, after setting all properties.
function popupmenu_NormMode_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_NormMode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_hideunclassifiedcells.
function checkbox_hideunclassifiedcells_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_hideunclassifiedcells (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_hideunclassifiedcells


% --- Executes on selection change in popupmenu_colorbar.
function popupmenu_colorbar_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu_colorbar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu_colorbar contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu_colorbar


% --- Executes during object creation, after setting all properties.
function popupmenu_colorbar_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_colorbar (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
